require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_BITOPS_H)) {
    eval 'sub _ALPHA_BITOPS_H () {1;}' unless defined(&_ALPHA_BITOPS_H);
    require 'linux/config.ph';
    require 'linux/kernel.ph';
    eval 'sub smp_mb__before_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__before_clear_bit);
    eval 'sub smp_mb__after_clear_bit () {
        eval q( &smp_mb());
    }' unless defined(&smp_mb__after_clear_bit);
    eval 'sub clear_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&clear_bit);
    eval 'sub change_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&change_bit);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub test_and_set_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&test_and_set_bit);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub test_and_clear_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&test_and_clear_bit);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub test_and_change_bit {
        my($nr,$addr) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&test_and_change_bit);
    eval 'sub test_bit {
        my($nr,$addr) = @_;
	    eval q({ (1 & ((( &const \'int\' *) $addr)[$nr >> 5] >> ($nr & 31))) != 0; });
    }' unless defined(&test_bit);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub ffz {
        my($word) = @_;
	    eval q({ });
    }' unless defined(&ffz);
    if(defined(&__KERNEL__)) {
	if(defined( &__alpha_cix__)  && defined( &__alpha_fix__)) {
	} else {
	}
	eval 'sub ceil_log2 {
	    my($word) = @_;
    	    eval q({ my $bit =  &floor_log2($word);  $bit + ($word > (1 <<  $bit)); });
	}' unless defined(&ceil_log2);
	if(defined( &__alpha_cix__)  && defined( &__alpha_fix__)) {
	    eval 'sub hweight32 {
	        my($x) = @_;
    		eval q( &hweight64(($x) & 0xffffffff));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        my($x) = @_;
    		eval q( &hweight64(($x) & 0xffff));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        my($x) = @_;
    		eval q( &hweight64(($x) & 0xff));
	    }' unless defined(&hweight8);
	} else {
	    eval 'sub hweight32 {
	        my($x) = @_;
    		eval q( &generic_hweight32($x));
	    }' unless defined(&hweight32);
	    eval 'sub hweight16 {
	        my($x) = @_;
    		eval q( &generic_hweight16($x));
	    }' unless defined(&hweight16);
	    eval 'sub hweight8 {
	        my($x) = @_;
    		eval q( &generic_hweight8($x));
	    }' unless defined(&hweight8);
	}
    }
    eval 'sub find_first_zero_bit {
        my($addr, $size) = @_;
	    eval q( &find_next_zero_bit(($addr), ($size), 0));
    }' unless defined(&find_first_zero_bit);
    if(defined(&__KERNEL__)) {
	eval 'sub ext2_set_bit () { &__test_and_set_bit;}' unless defined(&ext2_set_bit);
	eval 'sub ext2_clear_bit () { &__test_and_clear_bit;}' unless defined(&ext2_clear_bit);
	eval 'sub ext2_test_bit () { &test_bit;}' unless defined(&ext2_test_bit);
	eval 'sub ext2_find_first_zero_bit () { &find_first_zero_bit;}' unless defined(&ext2_find_first_zero_bit);
	eval 'sub ext2_find_next_zero_bit () { &find_next_zero_bit;}' unless defined(&ext2_find_next_zero_bit);
	eval 'sub minix_test_and_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_set_bit($nr,$addr));
	}' unless defined(&minix_test_and_set_bit);
	eval 'sub minix_set_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__set_bit($nr,$addr));
	}' unless defined(&minix_set_bit);
	eval 'sub minix_test_and_clear_bit {
	    my($nr,$addr) = @_;
    	    eval q( &__test_and_clear_bit($nr,$addr));
	}' unless defined(&minix_test_and_clear_bit);
	eval 'sub minix_test_bit {
	    my($nr,$addr) = @_;
    	    eval q( &test_bit($nr,$addr));
	}' unless defined(&minix_test_bit);
	eval 'sub minix_find_first_zero_bit {
	    my($addr,$size) = @_;
    	    eval q( &find_first_zero_bit($addr,$size));
	}' unless defined(&minix_find_first_zero_bit);
    }
}
1;
