require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_IRONGATE__H__)) {
    eval 'sub __ALPHA_IRONGATE__H__ () {1;}' unless defined(&__ALPHA_IRONGATE__H__);
    require 'linux/types.ph';
    require 'asm/compiler.ph';
    if(defined(&USE_48_BIT_KSEG)) {
	eval 'sub IRONGATE_BIAS () {0x80000000000;}' unless defined(&IRONGATE_BIAS);
    } else {
	eval 'sub IRONGATE_BIAS () {0x10000000000;}' unless defined(&IRONGATE_BIAS);
    }
    eval 'sub IRONGATE_MEM () {( &IDENT_ADDR |  &IRONGATE_BIAS | 0x);}' unless defined(&IRONGATE_MEM);
    eval 'sub IRONGATE_IACK_SC () {( &IDENT_ADDR |  &IRONGATE_BIAS | 0x1f8000000);}' unless defined(&IRONGATE_IACK_SC);
    eval 'sub IRONGATE_IO () {( &IDENT_ADDR |  &IRONGATE_BIAS | 0x1fc000000);}' unless defined(&IRONGATE_IO);
    eval 'sub IRONGATE_CONF () {( &IDENT_ADDR |  &IRONGATE_BIAS | 0x1fe000000);}' unless defined(&IRONGATE_CONF);
    eval 'sub IGCSR {
        my($dev,$fun,$reg) = @_;
	    eval q((  &IRONGATE_CONF | (($dev)<<11) | (($fun)<<8) | ($reg) ));
    }' unless defined(&IGCSR);
    eval 'sub IRONGATE0 () {(( &Irongate0 *)  &IGCSR(0, 0, 0));}' unless defined(&IRONGATE0);
    eval 'sub IRONGATE1 () {(( &Irongate1 *)  &IGCSR(1, 0, 0));}' unless defined(&IRONGATE1);
    eval 'sub SCB_Q_SYSERR () {0x620;}' unless defined(&SCB_Q_SYSERR);
    eval 'sub SCB_Q_PROCERR () {0x630;}' unless defined(&SCB_Q_PROCERR);
    eval 'sub SCB_Q_SYSMCHK () {0x660;}' unless defined(&SCB_Q_SYSMCHK);
    eval 'sub SCB_Q_PROCMCHK () {0x670;}' unless defined(&SCB_Q_PROCMCHK);
    if(defined(&__KERNEL__)) {
	unless(defined(&__EXTERN_INLINE)) {
	    eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	    eval 'sub __IO_EXTERN_INLINE () {1;}' unless defined(&__IO_EXTERN_INLINE);
	}
	eval 'sub vucp () { &volatile \'unsigned char\' *;}' unless defined(&vucp);
	eval 'sub vusp () { &volatile \'unsigned short\' *;}' unless defined(&vusp);
	eval 'sub vuip () { &volatile \'unsigned int\' *;}' unless defined(&vuip);
	eval 'sub vulp () { &volatile \'unsigned long\' *;}' unless defined(&vulp);
	undef(&vucp) if defined(&vucp);
	undef(&vusp) if defined(&vusp);
	undef(&vuip) if defined(&vuip);
	undef(&vulp) if defined(&vulp);
	if(defined(&__WANT_IO_DEF)) {
	    eval 'sub __inb {
	        my($p) = @_;
    		eval q( &irongate_inb(($p)));
	    }' unless defined(&__inb);
	    eval 'sub __inw {
	        my($p) = @_;
    		eval q( &irongate_inw(($p)));
	    }' unless defined(&__inw);
	    eval 'sub __inl {
	        my($p) = @_;
    		eval q( &irongate_inl(($p)));
	    }' unless defined(&__inl);
	    eval 'sub __outb {
	        my($x,$p) = @_;
    		eval q( &irongate_outb(,($p)));
	    }' unless defined(&__outb);
	    eval 'sub __outw {
	        my($x,$p) = @_;
    		eval q( &irongate_outw(,($p)));
	    }' unless defined(&__outw);
	    eval 'sub __outl {
	        my($x,$p) = @_;
    		eval q( &irongate_outl(,($p)));
	    }' unless defined(&__outl);
	    eval 'sub __readb {
	        my($a) = @_;
    		eval q( &irongate_readb(($a)));
	    }' unless defined(&__readb);
	    eval 'sub __readw {
	        my($a) = @_;
    		eval q( &irongate_readw(($a)));
	    }' unless defined(&__readw);
	    eval 'sub __readl {
	        my($a) = @_;
    		eval q( &irongate_readl(($a)));
	    }' unless defined(&__readl);
	    eval 'sub __readq {
	        my($a) = @_;
    		eval q( &irongate_readq(($a)));
	    }' unless defined(&__readq);
	    eval 'sub __writeb {
	        my($x,$a) = @_;
    		eval q( &irongate_writeb(,($a)));
	    }' unless defined(&__writeb);
	    eval 'sub __writew {
	        my($x,$a) = @_;
    		eval q( &irongate_writew(,($a)));
	    }' unless defined(&__writew);
	    eval 'sub __writel {
	        my($x,$a) = @_;
    		eval q( &irongate_writel(,($a)));
	    }' unless defined(&__writel);
	    eval 'sub __writeq {
	        my($x,$a) = @_;
    		eval q( &irongate_writeq(,($a)));
	    }' unless defined(&__writeq);
	    eval 'sub __ioremap {
	        my($a,$s) = @_;
    		eval q( &irongate_ioremap(($a),($s)));
	    }' unless defined(&__ioremap);
	    eval 'sub __iounmap {
	        my($a) = @_;
    		eval q( &irongate_iounmap(($a)));
	    }' unless defined(&__iounmap);
	    eval 'sub __is_ioaddr {
	        my($a) = @_;
    		eval q( &irongate_is_ioaddr(($a)));
	    }' unless defined(&__is_ioaddr);
	    eval 'sub inb {
	        my($p) = @_;
    		eval q( &__inb($p));
	    }' unless defined(&inb);
	    eval 'sub inw {
	        my($p) = @_;
    		eval q( &__inw($p));
	    }' unless defined(&inw);
	    eval 'sub inl {
	        my($p) = @_;
    		eval q( &__inl($p));
	    }' unless defined(&inl);
	    eval 'sub outb {
	        my($x,$p) = @_;
    		eval q( &__outb(($x),($p)));
	    }' unless defined(&outb);
	    eval 'sub outw {
	        my($x,$p) = @_;
    		eval q( &__outw(($x),($p)));
	    }' unless defined(&outw);
	    eval 'sub outl {
	        my($x,$p) = @_;
    		eval q( &__outl(($x),($p)));
	    }' unless defined(&outl);
	    eval 'sub __raw_readb {
	        my($a) = @_;
    		eval q( &__readb($a));
	    }' unless defined(&__raw_readb);
	    eval 'sub __raw_readw {
	        my($a) = @_;
    		eval q( &__readw($a));
	    }' unless defined(&__raw_readw);
	    eval 'sub __raw_readl {
	        my($a) = @_;
    		eval q( &__readl($a));
	    }' unless defined(&__raw_readl);
	    eval 'sub __raw_readq {
	        my($a) = @_;
    		eval q( &__readq($a));
	    }' unless defined(&__raw_readq);
	    eval 'sub __raw_writeb {
	        my($v,$a) = @_;
    		eval q( &__writeb(($v),($a)));
	    }' unless defined(&__raw_writeb);
	    eval 'sub __raw_writew {
	        my($v,$a) = @_;
    		eval q( &__writew(($v),($a)));
	    }' unless defined(&__raw_writew);
	    eval 'sub __raw_writel {
	        my($v,$a) = @_;
    		eval q( &__writel(($v),($a)));
	    }' unless defined(&__raw_writel);
	    eval 'sub __raw_writeq {
	        my($v,$a) = @_;
    		eval q( &__writeq(($v),($a)));
	    }' unless defined(&__raw_writeq);
	}
	if(defined(&__IO_EXTERN_INLINE)) {
	    undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	    undef(&__IO_EXTERN_INLINE) if defined(&__IO_EXTERN_INLINE);
	}
    }
}
1;
