require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_TITAN__H__)) {
    eval 'sub __ALPHA_TITAN__H__ () {1;}' unless defined(&__ALPHA_TITAN__H__);
    require 'linux/types.ph';
    require 'asm/compiler.ph';
    if(defined(&USE_48_BIT_KSEG)) {
	eval 'sub TI_BIAS () {0x80000000000;}' unless defined(&TI_BIAS);
    } else {
	eval 'sub TI_BIAS () {0x10000000000;}' unless defined(&TI_BIAS);
    }
    eval 'sub TITAN_cchip () {(( &titan_cchip *)( &IDENT_ADDR+ &TI_BIAS+0x1a0000000));}' unless defined(&TITAN_cchip);
    eval 'sub TITAN_dchip () {(( &titan_dchip *)( &IDENT_ADDR+ &TI_BIAS+0x1b0000800));}' unless defined(&TITAN_dchip);
    eval 'sub TITAN_pachip0 () {(( &titan_pachip *)( &IDENT_ADDR+ &TI_BIAS+0x180000000));}' unless defined(&TITAN_pachip0);
    eval 'sub TITAN_pachip1 () {(( &titan_pachip *)( &IDENT_ADDR+ &TI_BIAS+0x380000000));}' unless defined(&TITAN_pachip1);
    eval 'sub wsba_m_ena () {0x1;}' unless defined(&wsba_m_ena);
    eval 'sub wsba_m_sg () {0x2;}' unless defined(&wsba_m_sg);
    eval 'sub wsba_m_addr () {0xfff00000;}' unless defined(&wsba_m_addr);
    eval 'sub wmask_k_sz1gb () {0x3ff00000;}' unless defined(&wmask_k_sz1gb);
    eval 'sub pctl_m_fbtb () {0x1;}' unless defined(&pctl_m_fbtb);
    eval 'sub pctl_m_thdis () {0x2;}' unless defined(&pctl_m_thdis);
    eval 'sub pctl_m_chaindis () {0x4;}' unless defined(&pctl_m_chaindis);
    eval 'sub pctl_m_tgtlat () {0x18;}' unless defined(&pctl_m_tgtlat);
    eval 'sub pctl_m_hole () {0x20;}' unless defined(&pctl_m_hole);
    eval 'sub pctl_m_mwin () {0x40;}' unless defined(&pctl_m_mwin);
    eval 'sub pctl_m_arbena () {0x80;}' unless defined(&pctl_m_arbena);
    eval 'sub pctl_m_prigrp () {0xff00;}' unless defined(&pctl_m_prigrp);
    eval 'sub pctl_m_ppri () {0x10000;}' unless defined(&pctl_m_ppri);
    eval 'sub pctl_m_pcispd66 () {0x20000;}' unless defined(&pctl_m_pcispd66);
    eval 'sub pctl_m_cngstlt () {0x3c0000;}' unless defined(&pctl_m_cngstlt);
    eval 'sub pctl_m_ptpdesten () {0x3fc00000;}' unless defined(&pctl_m_ptpdesten);
    eval 'sub pctl_m_dpcen () {0x40000000;}' unless defined(&pctl_m_dpcen);
    eval 'sub pctl_m_apcen () {0x80000000;}' unless defined(&pctl_m_apcen);
    eval 'sub pctl_m_dcrtv () {0x300000000;}' unless defined(&pctl_m_dcrtv);
    eval 'sub pctl_m_en_stepping () {0x400000000;}' unless defined(&pctl_m_en_stepping);
    eval 'sub apctl_m_rsvd1 () {0xffff800000000;}' unless defined(&apctl_m_rsvd1);
    eval 'sub apctl_m_agp_rate () {0x30000000000000;}' unless defined(&apctl_m_agp_rate);
    eval 'sub apctl_m_agp_sba_en () {0x40000000000000;}' unless defined(&apctl_m_agp_sba_en);
    eval 'sub apctl_m_agp_en () {0x80000000000000;}' unless defined(&apctl_m_agp_en);
    eval 'sub apctl_m_rsvd2 () {0x100000000000000;}' unless defined(&apctl_m_rsvd2);
    eval 'sub apctl_m_agp_present () {0x200000000000000;}' unless defined(&apctl_m_agp_present);
    eval 'sub apctl_agp_hp_rd () {0x1c00000000000000;}' unless defined(&apctl_agp_hp_rd);
    eval 'sub apctl_agp_lp_rd () {0xe000000000000000;}' unless defined(&apctl_agp_lp_rd);
    eval 'sub gpctl_m_rsvd () {0xfffffff800000000;}' unless defined(&gpctl_m_rsvd);
    eval 'sub TITAN_HOSE {
        my($h) = @_;
	    eval q(((($h)) << 33));
    }' unless defined(&TITAN_HOSE);
    eval 'sub TITAN_BASE () {( &IDENT_ADDR +  &TI_BIAS);}' unless defined(&TITAN_BASE);
    eval 'sub TITAN_MEM {
        my($h) = @_;
	    eval q(( &TITAN_BASE+ &TITAN_HOSE($h)+0x));
    }' unless defined(&TITAN_MEM);
    eval 'sub _TITAN_IACK_SC {
        my($h) = @_;
	    eval q(( &TITAN_BASE+ &TITAN_HOSE($h)+0x1f8000000));
    }' unless defined(&_TITAN_IACK_SC);
    eval 'sub TITAN_IO {
        my($h) = @_;
	    eval q(( &TITAN_BASE+ &TITAN_HOSE($h)+0x1fc000000));
    }' unless defined(&TITAN_IO);
    eval 'sub TITAN_CONF {
        my($h) = @_;
	    eval q(( &TITAN_BASE+ &TITAN_HOSE($h)+0x1fe000000));
    }' unless defined(&TITAN_CONF);
    eval 'sub TITAN_IACK_SC () { &_TITAN_IACK_SC(0);}' unless defined(&TITAN_IACK_SC);
    eval 'sub TITAN_IO_BIAS () { &TITAN_IO(0);}' unless defined(&TITAN_IO_BIAS);
    eval 'sub TITAN_MEM_BIAS () { &TITAN_MEM(0);}' unless defined(&TITAN_MEM_BIAS);
    eval 'sub TITAN_IO_SPACE () {( &TITAN_CONF(0) -  &TITAN_IO(0));}' unless defined(&TITAN_IO_SPACE);
    eval 'sub TITAN_TIG_SPACE () {( &TITAN_BASE + 0x100000000);}' unless defined(&TITAN_TIG_SPACE);
    eval 'sub TITAN_DAC_OFFSET () {(1 << 40);}' unless defined(&TITAN_DAC_OFFSET);
    eval 'sub SCB_Q_SYSERR () {0x620;}' unless defined(&SCB_Q_SYSERR);
    eval 'sub SCB_Q_PROCERR () {0x630;}' unless defined(&SCB_Q_PROCERR);
    eval 'sub SCB_Q_SYSMCHK () {0x660;}' unless defined(&SCB_Q_SYSMCHK);
    eval 'sub SCB_Q_PROCMCHK () {0x670;}' unless defined(&SCB_Q_PROCMCHK);
    eval 'sub SCB_Q_SYSEVENT () {0x680;}' unless defined(&SCB_Q_SYSEVENT);
    if(defined(&__KERNEL__)) {
	unless(defined(&__EXTERN_INLINE)) {
	    eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	    eval 'sub __IO_EXTERN_INLINE () {1;}' unless defined(&__IO_EXTERN_INLINE);
	}
	eval 'sub vucp () { &volatile \'unsigned char\' *;}' unless defined(&vucp);
	eval 'sub vusp () { &volatile \'unsigned short\' *;}' unless defined(&vusp);
	eval 'sub vuip () { &volatile \'unsigned int\' *;}' unless defined(&vuip);
	eval 'sub vulp () { &volatile \'unsigned long\' *;}' unless defined(&vulp);
	undef(&vucp) if defined(&vucp);
	undef(&vusp) if defined(&vusp);
	undef(&vuip) if defined(&vuip);
	undef(&vulp) if defined(&vulp);
	if(defined(&__WANT_IO_DEF)) {
	    eval 'sub __inb {
	        my($p) = @_;
    		eval q( &titan_inb(($p)));
	    }' unless defined(&__inb);
	    eval 'sub __inw {
	        my($p) = @_;
    		eval q( &titan_inw(($p)));
	    }' unless defined(&__inw);
	    eval 'sub __inl {
	        my($p) = @_;
    		eval q( &titan_inl(($p)));
	    }' unless defined(&__inl);
	    eval 'sub __outb {
	        my($x,$p) = @_;
    		eval q( &titan_outb(,($p)));
	    }' unless defined(&__outb);
	    eval 'sub __outw {
	        my($x,$p) = @_;
    		eval q( &titan_outw(,($p)));
	    }' unless defined(&__outw);
	    eval 'sub __outl {
	        my($x,$p) = @_;
    		eval q( &titan_outl(,($p)));
	    }' unless defined(&__outl);
	    eval 'sub __readb {
	        my($a) = @_;
    		eval q( &titan_readb(($a)));
	    }' unless defined(&__readb);
	    eval 'sub __readw {
	        my($a) = @_;
    		eval q( &titan_readw(($a)));
	    }' unless defined(&__readw);
	    eval 'sub __readl {
	        my($a) = @_;
    		eval q( &titan_readl(($a)));
	    }' unless defined(&__readl);
	    eval 'sub __readq {
	        my($a) = @_;
    		eval q( &titan_readq(($a)));
	    }' unless defined(&__readq);
	    eval 'sub __writeb {
	        my($x,$a) = @_;
    		eval q( &titan_writeb(,($a)));
	    }' unless defined(&__writeb);
	    eval 'sub __writew {
	        my($x,$a) = @_;
    		eval q( &titan_writew(,($a)));
	    }' unless defined(&__writew);
	    eval 'sub __writel {
	        my($x,$a) = @_;
    		eval q( &titan_writel(,($a)));
	    }' unless defined(&__writel);
	    eval 'sub __writeq {
	        my($x,$a) = @_;
    		eval q( &titan_writeq(,($a)));
	    }' unless defined(&__writeq);
	    eval 'sub __ioremap {
	        my($a,$s) = @_;
    		eval q( &titan_ioremap(($a),($s)));
	    }' unless defined(&__ioremap);
	    eval 'sub __iounmap {
	        my($a) = @_;
    		eval q( &titan_iounmap(($a)));
	    }' unless defined(&__iounmap);
	    eval 'sub __is_ioaddr {
	        my($a) = @_;
    		eval q( &titan_is_ioaddr(($a)));
	    }' unless defined(&__is_ioaddr);
	    eval 'sub inb {
	        my($port) = @_;
    		eval q( &__inb(($port)));
	    }' unless defined(&inb);
	    eval 'sub inw {
	        my($port) = @_;
    		eval q( &__inw(($port)));
	    }' unless defined(&inw);
	    eval 'sub inl {
	        my($port) = @_;
    		eval q( &__inl(($port)));
	    }' unless defined(&inl);
	    eval 'sub outb {
	        my($v, $port) = @_;
    		eval q( &__outb(($v),($port)));
	    }' unless defined(&outb);
	    eval 'sub outw {
	        my($v, $port) = @_;
    		eval q( &__outw(($v),($port)));
	    }' unless defined(&outw);
	    eval 'sub outl {
	        my($v, $port) = @_;
    		eval q( &__outl(($v),($port)));
	    }' unless defined(&outl);
	    eval 'sub __raw_readb {
	        my($a) = @_;
    		eval q( &__readb(($a)));
	    }' unless defined(&__raw_readb);
	    eval 'sub __raw_readw {
	        my($a) = @_;
    		eval q( &__readw(($a)));
	    }' unless defined(&__raw_readw);
	    eval 'sub __raw_readl {
	        my($a) = @_;
    		eval q( &__readl(($a)));
	    }' unless defined(&__raw_readl);
	    eval 'sub __raw_readq {
	        my($a) = @_;
    		eval q( &__readq(($a)));
	    }' unless defined(&__raw_readq);
	    eval 'sub __raw_writeb {
	        my($v,$a) = @_;
    		eval q( &__writeb(,($a)));
	    }' unless defined(&__raw_writeb);
	    eval 'sub __raw_writew {
	        my($v,$a) = @_;
    		eval q( &__writew(,($a)));
	    }' unless defined(&__raw_writew);
	    eval 'sub __raw_writel {
	        my($v,$a) = @_;
    		eval q( &__writel(,($a)));
	    }' unless defined(&__raw_writel);
	    eval 'sub __raw_writeq {
	        my($v,$a) = @_;
    		eval q( &__writeq(,($a)));
	    }' unless defined(&__raw_writeq);
	}
	if(defined(&__IO_EXTERN_INLINE)) {
	    undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	    undef(&__IO_EXTERN_INLINE) if defined(&__IO_EXTERN_INLINE);
	}
    }
}
1;
