require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_MMU_CONTEXT_H)) {
    eval 'sub __ALPHA_MMU_CONTEXT_H () {1;}' unless defined(&__ALPHA_MMU_CONTEXT_H);
    require 'linux/config.ph';
    require 'asm/system.ph';
    require 'asm/machvec.ph';
    unless(defined(&__EXTERN_INLINE)) {
	require 'asm/io.ph';
    }
    eval 'sub __reload_thread {
        my($pcb) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__reload_thread);
    eval 'sub EV4_MAX_ASN () {63;}' unless defined(&EV4_MAX_ASN);
    eval 'sub EV5_MAX_ASN () {127;}' unless defined(&EV5_MAX_ASN);
    eval 'sub EV6_MAX_ASN () {255;}' unless defined(&EV6_MAX_ASN);
    if(defined(&CONFIG_ALPHA_GENERIC)) {
	eval 'sub MAX_ASN () {( ($alpha_mv->{max_asn}));}' unless defined(&MAX_ASN);
    } else {
	if(defined(&CONFIG_ALPHA_EV4)) {
	    eval 'sub MAX_ASN () { &EV4_MAX_ASN;}' unless defined(&MAX_ASN);
	}
 elsif(defined( &CONFIG_ALPHA_EV5)) {
	    eval 'sub MAX_ASN () { &EV5_MAX_ASN;}' unless defined(&MAX_ASN);
	} else {
	    eval 'sub MAX_ASN () { &EV6_MAX_ASN;}' unless defined(&MAX_ASN);
	}
    }
    if(defined(&CONFIG_SMP)) {
	require 'asm/smp.ph';
	eval 'sub cpu_last_asn {
	    my($cpuid) = @_;
    	    eval q(( ($cpu_data[$cpuid]->{last_asn})));
	}' unless defined(&cpu_last_asn);
    } else {
	eval 'sub cpu_last_asn {
	    my($cpuid) = @_;
    	    eval q( &last_asn);
	}' unless defined(&cpu_last_asn);
    }
    eval 'sub WIDTH_HARDWARE_ASN () {8;}' unless defined(&WIDTH_HARDWARE_ASN);
    eval 'sub ASN_FIRST_VERSION () {(1 <<  &WIDTH_HARDWARE_ASN);}' unless defined(&ASN_FIRST_VERSION);
    eval 'sub HARDWARE_ASN_MASK () {((1 <<  &WIDTH_HARDWARE_ASN) - 1);}' unless defined(&HARDWARE_ASN_MASK);
    unless(defined(&__EXTERN_INLINE)) {
	eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	eval 'sub __MMU_EXTERN_INLINE () {1;}' unless defined(&__MMU_EXTERN_INLINE);
    }
    eval 'sub __get_new_mm_context {
        my($mm,$cpu) = @_;
	    eval q({ my $asn =  &cpu_last_asn($cpu); my $next =  $asn + 1;  &if (( $asn &  &HARDWARE_ASN_MASK) >=  &MAX_ASN) {  &tbiap();  &imb();  $next = ( $asn & ~ &HARDWARE_ASN_MASK) +  &ASN_FIRST_VERSION; }  &cpu_last_asn($cpu) =  $next;  $next; });
    }' unless defined(&__get_new_mm_context);
    if(defined(&CONFIG_SMP)) {
    }
    if(defined(&CONFIG_SMP)) {
    }
    if(defined(&CONFIG_SMP)) {
	eval 'sub check_mmu_context () {
	    eval q( &do { \'int\'  &cpu =  &smp_processor_id();  ($cpu_data[&cpu]->{asn_lock}) = 0;  &barrier();  &if ( ($cpu_data[&cpu]->{need_new_asn})) { \'struct mm_struct\' *  &mm =  ($current->{active_mm});  ($cpu_data[&cpu]->{need_new_asn}) = 0;  &if (! ($mm->{context[&cpu]}))  &__load_new_mm_context( &mm); } }  &while(0));
	}' unless defined(&check_mmu_context);
    } else {
	eval 'sub check_mmu_context () {
	    eval q( &do { }  &while(0));
	}' unless defined(&check_mmu_context);
    }
    if(defined(&CONFIG_ALPHA_GENERIC)) {
	eval 'sub switch_mm {
	    my($a,$b,$c,$d) = @_;
    	    eval q( ($alpha_mv->{mv_switch_mm})(($a),($b),($c),($d)));
	}' unless defined(&switch_mm);
	eval 'sub activate_mm {
	    my($x,$y) = @_;
    	    eval q( ($alpha_mv->{mv_activate_mm})(($x),($y)));
	}' unless defined(&activate_mm);
    } else {
	if(defined(&CONFIG_ALPHA_EV4)) {
	    eval 'sub switch_mm {
	        my($a,$b,$c,$d) = @_;
    		eval q( &ev4_switch_mm(($a),($b),($c),($d)));
	    }' unless defined(&switch_mm);
	    eval 'sub activate_mm {
	        my($x,$y) = @_;
    		eval q( &ev4_activate_mm(($x),($y)));
	    }' unless defined(&activate_mm);
	} else {
	    eval 'sub switch_mm {
	        my($a,$b,$c,$d) = @_;
    		eval q( &ev5_switch_mm(($a),($b),($c),($d)));
	    }' unless defined(&switch_mm);
	    eval 'sub activate_mm {
	        my($x,$y) = @_;
    		eval q( &ev5_activate_mm(($x),($y)));
	    }' unless defined(&activate_mm);
	}
    }
    eval 'sub init_new_context {
        my($tsk,$mm) = @_;
	    eval q({ \'int\'  &i;  &for ( &i = 0;  &i <  &smp_num_cpus;  &i++)  ($mm->{context[&cpu_logical_map]}) = 0;  ($tsk->{thread}->{ptbr}) = ( ($mm->{pgd}) -  &IDENT_ADDR) >>  &PAGE_SHIFT; 0; });
    }' unless defined(&init_new_context);
    if(defined(&__MMU_EXTERN_INLINE)) {
	undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	undef(&__MMU_EXTERN_INLINE) if defined(&__MMU_EXTERN_INLINE);
    }
}
1;
