require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_PGALLOC_H)) {
    eval 'sub _ALPHA_PGALLOC_H () {1;}' unless defined(&_ALPHA_PGALLOC_H);
    require 'linux/config.ph';
    unless(defined(&__EXTERN_INLINE)) {
	eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	eval 'sub __MMU_EXTERN_INLINE () {1;}' unless defined(&__MMU_EXTERN_INLINE);
    }
    eval 'sub flush_cache_all () {
        eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_all);
    eval 'sub flush_cache_mm {
        my($mm) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_mm);
    eval 'sub flush_cache_range {
        my($mm, $start, $end) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_range);
    eval 'sub flush_cache_page {
        my($vma, $vmaddr) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_cache_page);
    eval 'sub flush_page_to_ram {
        my($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_page_to_ram);
    eval 'sub flush_dcache_page {
        my($page) = @_;
	    eval q( &do { }  &while (0));
    }' unless defined(&flush_dcache_page);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_icache_range {
	    my($start, $end) = @_;
    	    eval q( &imb());
	}' unless defined(&flush_icache_range);
    } else {
	eval 'sub flush_icache_range {
	    my($start, $end) = @_;
    	    eval q( &smp_imb());
	}' unless defined(&flush_icache_range);
    }
    eval 'sub flush_tlb_other {
        my($mm) = @_;
	    eval q({ \'long\' *  &mmc =  ($mm->{context[&smp_processor_id()]});  &if (* &mmc) * &mmc = 0; });
    }' unless defined(&flush_tlb_other);
    unless(defined(&CONFIG_SMP)) {
	eval 'sub flush_icache_page {
	    my($vma,$page) = @_;
    	    eval q({  &if ( ($vma->{vm_flags}) &  &VM_EXEC) { \'struct mm_struct\' * &mm =  ($vma->{vm_mm});  &if ( ($current->{active_mm}) ==  &mm)  &__load_new_mm_context( &mm);  &else  ($mm->{context[&smp_processor_id()]}) = 0; } });
	}' unless defined(&flush_icache_page);
    } else {
    }
    if(defined(&CONFIG_ALPHA_GENERIC)) {
	eval 'sub flush_tlb_current () { ($alpha_mv->{mv_flush_tlb_current});}' unless defined(&flush_tlb_current);
	eval 'sub flush_tlb_current_page () { ($alpha_mv->{mv_flush_tlb_current_page});}' unless defined(&flush_tlb_current_page);
    } else {
	if(defined(&CONFIG_ALPHA_EV4)) {
	    eval 'sub flush_tlb_current () { &ev4_flush_tlb_current;}' unless defined(&flush_tlb_current);
	    eval 'sub flush_tlb_current_page () { &ev4_flush_tlb_current_page;}' unless defined(&flush_tlb_current_page);
	} else {
	    eval 'sub flush_tlb_current () { &ev5_flush_tlb_current;}' unless defined(&flush_tlb_current);
	    eval 'sub flush_tlb_current_page () { &ev5_flush_tlb_current_page;}' unless defined(&flush_tlb_current_page);
	}
    }
    if(defined(&__MMU_EXTERN_INLINE)) {
	undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	undef(&__MMU_EXTERN_INLINE) if defined(&__MMU_EXTERN_INLINE);
    }
    unless(defined(&CONFIG_SMP)) {
    } else {
    }
    unless(defined(&CONFIG_SMP)) {
    } else {
	require 'asm/smp.ph';
	eval 'sub quicklists () { $cpu_data[ &smp_processor_id()];}' unless defined(&quicklists);
    }
    eval 'sub pgd_quicklist () {( ($quicklists->{pgd_cache}));}' unless defined(&pgd_quicklist);
    eval 'sub pmd_quicklist () {( ($quicklists->{pmd_cache}));}' unless defined(&pmd_quicklist);
    eval 'sub pte_quicklist () {( ($quicklists->{pte_cache}));}' unless defined(&pte_quicklist);
    eval 'sub pgtable_cache_size () {( ($quicklists->{pgtable_cache_sz}));}' unless defined(&pgtable_cache_size);
    eval 'sub pmd_populate {
        my($mm, $pmd, $pte) = @_;
	    eval q( &pmd_set($pmd, $pte));
    }' unless defined(&pmd_populate);
    eval 'sub pgd_populate {
        my($mm, $pgd, $pmd) = @_;
	    eval q( &pgd_set($pgd, $pmd));
    }' unless defined(&pgd_populate);
    eval 'sub pgd_t {
        eval q(* &get_pgd_fast { my $long * &ret;  &if (( &ret =  &pgd_quicklist) !=  &NULL) {  &pgd_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; }  &else  &ret =  &get_pgd_slow(); ( &pgd_t *) &ret; });
    }' unless defined(&pgd_t);
    eval 'sub free_pgd_fast {
        my($pgd) = @_;
	    eval q({ *$pgd =  &pgd_quicklist;  &pgd_quicklist = $pgd;  &pgtable_cache_size++; });
    }' unless defined(&free_pgd_fast);
    eval 'sub free_pgd_slow {
        my($pgd) = @_;
	    eval q({  &free_page($pgd); });
    }' unless defined(&free_pgd_slow);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pmd_t * &ret = ( &pmd_t *) &__get_free_page( &GFP_KERNEL);  &if ( &ret)  &clear_page( &ret);  &ret; });
    }' unless defined(&pmd_t);
    eval 'sub pmd_t {
        eval q(* &pmd_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { my $long * &ret;  &if (( &ret =  &pte_quicklist) !=  &NULL) {  &pte_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; } ( &pmd_t *) &ret; });
    }' unless defined(&pmd_t);
    eval 'sub pmd_free_fast {
        my($pmd) = @_;
	    eval q({ *$pmd =  &pte_quicklist;  &pte_quicklist = $pmd;  &pgtable_cache_size++; });
    }' unless defined(&pmd_free_fast);
    eval 'sub pmd_free_slow {
        my($pmd) = @_;
	    eval q({  &free_page($pmd); });
    }' unless defined(&pmd_free_slow);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one(\'struct mm_struct\' * &mm, my $address) {  &pte_t * &pte = ( &pte_t *) &__get_free_page( &GFP_KERNEL);  &if ( &pte)  &clear_page( &pte);  &pte; });
    }' unless defined(&pte_t);
    eval 'sub pte_t {
        eval q(* &pte_alloc_one_fast(\'struct mm_struct\' * &mm, my $address) { my $long * &ret;  &if (( &ret =  &pte_quicklist) !=  &NULL) {  &pte_quicklist = (* &ret);  $ret[0] = 0;  &pgtable_cache_size--; } ( &pte_t *) &ret; });
    }' unless defined(&pte_t);
    eval 'sub pte_free_fast {
        my($pte) = @_;
	    eval q({ *$pte =  &pte_quicklist;  &pte_quicklist = $pte;  &pgtable_cache_size++; });
    }' unless defined(&pte_free_fast);
    eval 'sub pte_free_slow {
        my($pte) = @_;
	    eval q({  &free_page($pte); });
    }' unless defined(&pte_free_slow);
    eval 'sub pte_free {
        my($pte) = @_;
	    eval q( &pte_free_fast($pte));
    }' unless defined(&pte_free);
    eval 'sub pmd_free {
        my($pmd) = @_;
	    eval q( &pmd_free_fast($pmd));
    }' unless defined(&pmd_free);
    eval 'sub pgd_free {
        my($pgd) = @_;
	    eval q( &free_pgd_fast($pgd));
    }' unless defined(&pgd_free);
    eval 'sub pgd_alloc {
        my($mm) = @_;
	    eval q( &get_pgd_fast());
    }' unless defined(&pgd_alloc);
}
1;
