require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_PGTABLE_H)) {
    eval 'sub _ALPHA_PGTABLE_H () {1;}' unless defined(&_ALPHA_PGTABLE_H);
    require 'linux/config.ph';
    require 'linux/mmzone.ph';
    require 'asm/page.ph';
    require 'asm/processor.ph';
    require 'asm/machvec.ph';
    eval 'sub set_pte {
        my($pteptr, $pteval) = @_;
	    eval q(((*($pteptr)) = ($pteval)));
    }' unless defined(&set_pte);
    eval 'sub PMD_SHIFT () {( &PAGE_SHIFT + ( &PAGE_SHIFT-3));}' unless defined(&PMD_SHIFT);
    eval 'sub PMD_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&PMD_SIZE);
    eval 'sub PMD_MASK () {(~( &PMD_SIZE-1));}' unless defined(&PMD_MASK);
    eval 'sub PGDIR_SHIFT () {( &PAGE_SHIFT + 2*( &PAGE_SHIFT-3));}' unless defined(&PGDIR_SHIFT);
    eval 'sub PGDIR_SIZE () {(1 <<  &PGDIR_SHIFT);}' unless defined(&PGDIR_SIZE);
    eval 'sub PGDIR_MASK () {(~( &PGDIR_SIZE-1));}' unless defined(&PGDIR_MASK);
    eval 'sub PTRS_PER_PTE () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PTE);
    eval 'sub PTRS_PER_PMD () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PMD);
    eval 'sub PTRS_PER_PGD () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PGD);
    eval 'sub USER_PTRS_PER_PGD () {( &TASK_SIZE /  &PGDIR_SIZE);}' unless defined(&USER_PTRS_PER_PGD);
    eval 'sub FIRST_USER_PGD_NR () {0;}' unless defined(&FIRST_USER_PGD_NR);
    eval 'sub PTRS_PER_PAGE () {(1 << ( &PAGE_SHIFT-3));}' unless defined(&PTRS_PER_PAGE);
    if(defined(&CONFIG_ALPHA_LARGE_VMALLOC)) {
	eval 'sub VMALLOC_START () {0xfffffe0000000000;}' unless defined(&VMALLOC_START);
    } else {
	eval 'sub VMALLOC_START () {(-2* &PGDIR_SIZE);}' unless defined(&VMALLOC_START);
    }
    eval 'sub VMALLOC_VMADDR {
        my($x) = @_;
	    eval q((($x)));
    }' unless defined(&VMALLOC_VMADDR);
    eval 'sub VMALLOC_END () {(- &PGDIR_SIZE);}' unless defined(&VMALLOC_END);
    eval 'sub _PAGE_VALID () {0x1;}' unless defined(&_PAGE_VALID);
    eval 'sub _PAGE_FOR () {0x2;}' unless defined(&_PAGE_FOR);
    eval 'sub _PAGE_FOW () {0x4;}' unless defined(&_PAGE_FOW);
    eval 'sub _PAGE_FOE () {0x8;}' unless defined(&_PAGE_FOE);
    eval 'sub _PAGE_ASM () {0x10;}' unless defined(&_PAGE_ASM);
    eval 'sub _PAGE_KRE () {0x100;}' unless defined(&_PAGE_KRE);
    eval 'sub _PAGE_URE () {0x200;}' unless defined(&_PAGE_URE);
    eval 'sub _PAGE_KWE () {0x1000;}' unless defined(&_PAGE_KWE);
    eval 'sub _PAGE_UWE () {0x2000;}' unless defined(&_PAGE_UWE);
    eval 'sub _PAGE_DIRTY () {0x20000;}' unless defined(&_PAGE_DIRTY);
    eval 'sub _PAGE_ACCESSED () {0x40000;}' unless defined(&_PAGE_ACCESSED);
    eval 'sub __DIRTY_BITS () {( &_PAGE_DIRTY |  &_PAGE_KWE |  &_PAGE_UWE);}' unless defined(&__DIRTY_BITS);
    eval 'sub __ACCESS_BITS () {( &_PAGE_ACCESSED |  &_PAGE_KRE |  &_PAGE_URE);}' unless defined(&__ACCESS_BITS);
    eval 'sub _PFN_MASK () {0xffffffff00000000;}' unless defined(&_PFN_MASK);
    eval 'sub _PAGE_TABLE () {( &_PAGE_VALID |  &__DIRTY_BITS |  &__ACCESS_BITS);}' unless defined(&_PAGE_TABLE);
    eval 'sub _PAGE_CHG_MASK () {( &_PFN_MASK |  &__DIRTY_BITS |  &__ACCESS_BITS);}' unless defined(&_PAGE_CHG_MASK);
    eval 'sub PAGE_NONE () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOR |  &_PAGE_FOW |  &_PAGE_FOE);}' unless defined(&PAGE_NONE);
    eval 'sub PAGE_SHARED () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS);}' unless defined(&PAGE_SHARED);
    eval 'sub PAGE_COPY () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOW);}' unless defined(&PAGE_COPY);
    eval 'sub PAGE_READONLY () { &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS |  &_PAGE_FOW);}' unless defined(&PAGE_READONLY);
    eval 'sub PAGE_KERNEL () { &__pgprot( &_PAGE_VALID |  &_PAGE_ASM |  &_PAGE_KRE |  &_PAGE_KWE);}' unless defined(&PAGE_KERNEL);
    eval 'sub _PAGE_NORMAL {
        my($x) = @_;
	    eval q( &__pgprot( &_PAGE_VALID |  &__ACCESS_BITS | ($x)));
    }' unless defined(&_PAGE_NORMAL);
    eval 'sub _PAGE_P {
        my($x) = @_;
	    eval q( &_PAGE_NORMAL(($x) | ((($x) &  &_PAGE_FOW)?0: &_PAGE_FOW)));
    }' unless defined(&_PAGE_P);
    eval 'sub _PAGE_S {
        my($x) = @_;
	    eval q( &_PAGE_NORMAL($x));
    }' unless defined(&_PAGE_S);
    eval 'sub __P000 () { &_PAGE_P( &_PAGE_FOE |  &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__P000);
    eval 'sub __P001 () { &_PAGE_P( &_PAGE_FOE |  &_PAGE_FOW);}' unless defined(&__P001);
    eval 'sub __P010 () { &_PAGE_P( &_PAGE_FOE);}' unless defined(&__P010);
    eval 'sub __P011 () { &_PAGE_P( &_PAGE_FOE);}' unless defined(&__P011);
    eval 'sub __P100 () { &_PAGE_P( &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__P100);
    eval 'sub __P101 () { &_PAGE_P( &_PAGE_FOW);}' unless defined(&__P101);
    eval 'sub __P110 () { &_PAGE_P(0);}' unless defined(&__P110);
    eval 'sub __P111 () { &_PAGE_P(0);}' unless defined(&__P111);
    eval 'sub __S000 () { &_PAGE_S( &_PAGE_FOE |  &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__S000);
    eval 'sub __S001 () { &_PAGE_S( &_PAGE_FOE |  &_PAGE_FOW);}' unless defined(&__S001);
    eval 'sub __S010 () { &_PAGE_S( &_PAGE_FOE);}' unless defined(&__S010);
    eval 'sub __S011 () { &_PAGE_S( &_PAGE_FOE);}' unless defined(&__S011);
    eval 'sub __S100 () { &_PAGE_S( &_PAGE_FOW |  &_PAGE_FOR);}' unless defined(&__S100);
    eval 'sub __S101 () { &_PAGE_S( &_PAGE_FOW);}' unless defined(&__S101);
    eval 'sub __S110 () { &_PAGE_S(0);}' unless defined(&__S110);
    eval 'sub __S111 () { &_PAGE_S(0);}' unless defined(&__S111);
    eval 'sub BAD_PAGETABLE () { &__bad_pagetable();}' unless defined(&BAD_PAGETABLE);
    eval 'sub BAD_PAGE () { &__bad_page();}' unless defined(&BAD_PAGE);
    eval 'sub ZERO_PAGE {
        my($vaddr) = @_;
	    eval q(( &virt_to_page( &ZERO_PGE)));
    }' unless defined(&ZERO_PAGE);
    eval 'sub BITS_PER_PTR () {(8*$sizeof{\'unsigned long\'});}' unless defined(&BITS_PER_PTR);
    eval 'sub PTR_MASK () {(~($sizeof{ &void}-1));}' unless defined(&PTR_MASK);
    eval 'sub SIZEOF_PTR_LOG2 () {3;}' unless defined(&SIZEOF_PTR_LOG2);
    eval 'sub PAGE_PTR {
        my($address) = @_;
	    eval q((($address)>>( &PAGE_SHIFT- &SIZEOF_PTR_LOG2) &PTR_MASK&~ &PAGE_MASK));
    }' unless defined(&PAGE_PTR);
    if(defined( &CONFIG_ALPHA_GENERIC)  && defined( &USE_48_BIT_KSEG)) {
	die("EV6-only feature in a generic kernel");
    }
    if(defined( &CONFIG_ALPHA_GENERIC) || ((defined( &CONFIG_ALPHA_EV6) || defined( &CONFIG_ALPHA_EV67))  && !defined( &USE_48_BIT_KSEG))) {
	eval 'sub PHYS_TWIDDLE {
	    my($phys) = @_;
    	    eval q((((($phys) & 0xc0000000000) == 0x40000000000) ? (($phys) ^= 0xc0000000000) : ($phys)));
	}' unless defined(&PHYS_TWIDDLE);
    } else {
	eval 'sub PHYS_TWIDDLE {
	    my($phys) = @_;
    	    eval q(($phys));
	}' unless defined(&PHYS_TWIDDLE);
    }
    unless(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub PAGE_TO_PA {
	    my($page) = @_;
    	    eval q((($page -  &mem_map) <<  &PAGE_SHIFT));
	}' unless defined(&PAGE_TO_PA);
    } else {
	eval 'sub PAGE_TO_PA {
	    my($page) = @_;
    	    eval q((((($page)-($page)-> ($zone->{zone_mem_map})) <<  &PAGE_SHIFT) + ($page)-> ($zone->{zone_start_paddr})));
	}' unless defined(&PAGE_TO_PA);
    }
    unless(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub mk_pte {
	    my($page, $pgprot) = @_;
    	    eval q(({  &pte_t  &pte;  &pte_val = (($page -  &mem_map) << 32) |  &pgprot_val($pgprot);  &pte; }));
	}' unless defined(&mk_pte);
    } else {
	eval 'sub mk_pte {
	    my($page, $pgprot) = @_;
    	    eval q(({  &pte_t  &pte; \'unsigned long pfn\';  &pfn = ((($page)-($page)-> ($zone->{zone_mem_map}))) << 32;  &pfn += ($page)-> ($zone->{zone_start_paddr}) << (32- &PAGE_SHIFT);  &pte_val( &pte) =  &pfn |  &pgprot_val($pgprot);  &pte; }));
	}' unless defined(&mk_pte);
    }
    eval 'sub mk_pte_phys {
        my($physpage,$pgprot) = @_;
	    eval q({  &pte_t  &pte;  &pte_val( &pte) = ( &PHYS_TWIDDLE($physpage) << (32- &PAGE_SHIFT)) |  &pgprot_val($pgprot);  &pte; });
    }' unless defined(&mk_pte_phys);
    eval 'sub pte_modify {
        my($pte,$newprot) = @_;
	    eval q({  &pte_val($pte) = ( &pte_val($pte) &  &_PAGE_CHG_MASK) |  &pgprot_val($newprot); $pte; });
    }' unless defined(&pte_modify);
    eval 'sub pmd_set {
        my($pmdp,$ptep) = @_;
	    eval q({  &pmd_val(*$pmdp) =  &_PAGE_TABLE | ((( $ptep) -  &PAGE_OFFSET) << (32- &PAGE_SHIFT)); });
    }' unless defined(&pmd_set);
    eval 'sub pgd_set {
        my($pgdp,$pmdp) = @_;
	    eval q({  &pgd_val(*$pgdp) =  &_PAGE_TABLE | ((( $pmdp) -  &PAGE_OFFSET) << (32- &PAGE_SHIFT)); });
    }' unless defined(&pgd_set);
    unless(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub pte_page {
	    my($x) = @_;
    	    eval q(( &mem_map+(( &pte_val($x) >> 32))));
	}' unless defined(&pte_page);
    } else {
	eval 'sub pte_page {
	    my($x) = @_;
    	    eval q(({ \'unsigned long kvirt\'; \'struct page\' *  &__xx;  &kvirt =  &__va( &pte_val($x) >> (32- &PAGE_SHIFT));  &__xx =  &virt_to_page( &kvirt);  &__xx; }));
	}' unless defined(&pte_page);
    }
    eval 'sub pmd_page {
        my($pmd) = @_;
	    eval q({  &PAGE_OFFSET + (( &pmd_val($pmd) &  &_PFN_MASK) >> (32- &PAGE_SHIFT)); });
    }' unless defined(&pmd_page);
    eval 'sub pgd_page {
        my($pgd) = @_;
	    eval q({  &PAGE_OFFSET + (( &pgd_val($pgd) &  &_PFN_MASK) >> (32- &PAGE_SHIFT)); });
    }' unless defined(&pgd_page);
    eval 'sub pte_mkyoung {
        my($pte) = @_;
	    eval q({  &pte_val($pte) |=  &__ACCESS_BITS; $pte; }  &define  &PAGE_DIR_OFFSET( &tsk, $address)  &pgd_offset(( &tsk),( $address))  &define  &pgd_offset_k( $address)  &pgd_offset( &init_mm,  $address)  &define  &pgd_index( $address) (( $address >>  &PGDIR_SHIFT) & ( &PTRS_PER_PGD - 1))  &define  &__pgd_offset( $address)  &pgd_index( $address)  &define  &pgd_offset( &mm,  $address) (( &mm)-> &pgd+ &pgd_index( $address))  &pmd_t *  &pmd_offset( &pgd_t *  &dir, my $address) { ( &pmd_t *)  &pgd_page(* &dir) + (( $address >>  &PMD_SHIFT) & ( &PTRS_PER_PAGE - 1)); });
    }' unless defined(&pte_mkyoung);
    eval 'sub SWP_TYPE {
        my($x) = @_;
	    eval q(((($x). &val >> 32) & 0xff));
    }' unless defined(&SWP_TYPE);
    eval 'sub SWP_OFFSET {
        my($x) = @_;
	    eval q((($x). &val >> 40));
    }' unless defined(&SWP_OFFSET);
    eval 'sub SWP_ENTRY {
        my($type, $offset) = @_;
	    eval q((( &swp_entry_t) {  &pte_val( &mk_swap_pte(($type),($offset))) }));
    }' unless defined(&SWP_ENTRY);
    eval 'sub pte_to_swp_entry {
        my($pte) = @_;
	    eval q((( &swp_entry_t) {  &pte_val($pte) }));
    }' unless defined(&pte_to_swp_entry);
    eval 'sub swp_entry_to_pte {
        my($x) = @_;
	    eval q((( &pte_t) { ($x). &val }));
    }' unless defined(&swp_entry_to_pte);
    eval 'sub PageSkip {
        my($page) = @_;
	    eval q((0));
    }' unless defined(&PageSkip);
    unless(defined(&CONFIG_DISCONTIGMEM)) {
	eval 'sub kern_addr_valid {
	    my($addr) = @_;
    	    eval q((1));
	}' unless defined(&kern_addr_valid);
    }
    eval 'sub io_remap_page_range {
        my($start, $busaddr, $size, $prot) = @_;
	    eval q( &remap_page_range($start,  &virt_to_phys( &__ioremap($busaddr, $size)), $size, $prot));
    }' unless defined(&io_remap_page_range);
    eval 'sub pte_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pte %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pte_val($e)));
    }' unless defined(&pte_ERROR);
    eval 'sub pmd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pmd %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pmd_val($e)));
    }' unless defined(&pmd_ERROR);
    eval 'sub pgd_ERROR {
        my($e) = @_;
	    eval q( &printk(\\"%s:%d: bad pgd %016lx.\\\\n\\",  &__FILE__,  &__LINE__,  &pgd_val($e)));
    }' unless defined(&pgd_ERROR);
    require 'asm-generic/pgtable.ph';
    eval 'sub pgtable_cache_init () {
        eval q( &do { }  &while (0));
    }' unless defined(&pgtable_cache_init);
}
1;
