require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_SEMAPHORE_H)) {
    eval 'sub _ALPHA_SEMAPHORE_H () {1;}' unless defined(&_ALPHA_SEMAPHORE_H);
    require 'asm/current.ph';
    require 'asm/system.ph';
    require 'asm/atomic.ph';
    require 'asm/compiler.ph';
    require 'linux/wait.ph';
    require 'linux/rwsem.ph';
    eval 'sub DEBUG_SEMAPHORE () {0;}' unless defined(&DEBUG_SEMAPHORE);
    eval 'sub DEBUG_RW_SEMAPHORE () {0;}' unless defined(&DEBUG_RW_SEMAPHORE);
    if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : undef)) {
    }
    if((defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : undef)) {
	eval 'sub __SEM_DEBUG_INIT {
	    my($name) = @_;
    	    eval q(, ($name). &__magic);
	}' unless defined(&__SEM_DEBUG_INIT);
    } else {
	eval 'sub __SEM_DEBUG_INIT {
	    my($name) = @_;
    	    eval q();
	}' unless defined(&__SEM_DEBUG_INIT);
    }
    eval 'sub __SEMAPHORE_INITIALIZER {
        my($name,$count) = @_;
	    eval q({  &ATOMIC_INIT($count),  &ATOMIC_INIT(-1),  &__WAIT_QUEUE_HEAD_INITIALIZER(($name). &wait)  &__SEM_DEBUG_INIT($name) });
    }' unless defined(&__SEMAPHORE_INITIALIZER);
    eval 'sub __MUTEX_INITIALIZER {
        my($name) = @_;
	    eval q( &__SEMAPHORE_INITIALIZER($name,1));
    }' unless defined(&__MUTEX_INITIALIZER);
    eval 'sub __DECLARE_SEMAPHORE_GENERIC {
        my($name,$count) = @_;
	    eval q(\'struct semaphore\' $name =  &__SEMAPHORE_INITIALIZER($name,$count));
    }' unless defined(&__DECLARE_SEMAPHORE_GENERIC);
    eval 'sub DECLARE_MUTEX {
        my($name) = @_;
	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,1));
    }' unless defined(&DECLARE_MUTEX);
    eval 'sub DECLARE_MUTEX_LOCKED {
        my($name) = @_;
	    eval q( &__DECLARE_SEMAPHORE_GENERIC($name,0));
    }' unless defined(&DECLARE_MUTEX_LOCKED);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub sema_init {
        my($sem,$val) = @_;
	    eval q({  &atomic_set( ($sem->{count}), $val);  &atomic_set( ($sem->{waking}), -1);  &init_waitqueue_head( ($sem->{wait})); });
    }' unless defined(&sema_init);
    eval 'sub init_MUTEX {
        my($sem) = @_;
	    eval q({  &sema_init($sem, 1); });
    }' unless defined(&init_MUTEX);
    eval 'sub init_MUTEX_LOCKED {
        my($sem) = @_;
	    eval q({  &sema_init($sem, 0); });
    }' unless defined(&init_MUTEX_LOCKED);
    eval 'sub __down_interruptible {
        my($sem) = @_;
	    eval q({ my $count =  &atomic_dec_return( ($sem->{count}));  &if ( &__builtin_expect( $count < 0, 0))  &__down_failed_interruptible($sem); 0; });
    }' unless defined(&__down_interruptible);
    eval 'sub __up {
        my($sem) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&__up);
    if(!(defined(&WAITQUEUE_DEBUG) ? &WAITQUEUE_DEBUG : undef)  && !(defined(&DEBUG_SEMAPHORE) ? &DEBUG_SEMAPHORE : undef)) {
	eval 'sub down {
	    my($sem) = @_;
    	    eval q({  &__down($sem); });
	}' unless defined(&down);
	eval 'sub down_interruptible {
	    my($sem) = @_;
    	    eval q({  &__down_interruptible($sem); });
	}' unless defined(&down_interruptible);
	eval 'sub down_trylock {
	    my($sem) = @_;
    	    eval q({  &__down_trylock($sem); });
	}' unless defined(&down_trylock);
	eval 'sub up {
	    my($sem) = @_;
    	    eval q({  &__up($sem); });
	}' unless defined(&up);
    }
}
1;
