require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ALPHA_SPINLOCK_H)) {
    eval 'sub _ALPHA_SPINLOCK_H () {1;}' unless defined(&_ALPHA_SPINLOCK_H);
    require 'asm/system.ph';
    require 'linux/kernel.ph';
    require 'asm/current.ph';
    eval 'sub DEBUG_SPINLOCK () {0;}' unless defined(&DEBUG_SPINLOCK);
    eval 'sub DEBUG_RWLOCK () {0;}' unless defined(&DEBUG_RWLOCK);
    if((defined(&DEBUG_SPINLOCK) ? &DEBUG_SPINLOCK : undef)) {
    }
    if((defined(&DEBUG_SPINLOCK) ? &DEBUG_SPINLOCK : undef)) {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) {0, -1, 0, 0, 0, 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q((($x)-> &lock = 0, ($x)-> &on_cpu = -1, ($x)-> &previous = 0, ($x)-> &task = 0));
	}' unless defined(&spin_lock_init);
    } else {
	eval 'sub SPIN_LOCK_UNLOCKED () {( &spinlock_t) { 0};}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock_init {
	    my($x) = @_;
    	    eval q((($x)-> &lock = 0));
	}' unless defined(&spin_lock_init);
    }
    eval 'sub spin_is_locked {
        my($x) = @_;
	    eval q((($x)-> &lock != 0));
    }' unless defined(&spin_is_locked);
    eval 'sub spin_unlock_wait {
        my($x) = @_;
	    eval q(({  &do {  &barrier(); }  &while (($x)-> &lock); }));
    }' unless defined(&spin_unlock_wait);
    if((defined(&DEBUG_SPINLOCK) ? &DEBUG_SPINLOCK : undef)) {
	eval 'sub spin_lock {
	    my($LOCK) = @_;
    	    eval q( &debug_spin_lock($LOCK,  &__BASE_FILE__,  &__LINE__));
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    my($LOCK) = @_;
    	    eval q( &debug_spin_trylock($LOCK,  &__BASE_FILE__,  &__LINE__));
	}' unless defined(&spin_trylock);
	eval 'sub spin_lock_own {
	    my($LOCK, $LOCATION) = @_;
    	    eval q( &do {  &if (!(($LOCK)-> &lock  && ($LOCK)-> &on_cpu ==  &smp_processor_id()))  &printk(\\"%s: called on %d from %p but lock %s on %d\\\\n\\", $LOCATION,  &smp_processor_id(),  &__builtin_return_address(0), ($LOCK)-> &lock ? \\"taken\\" : \\"freed\\", ($LOCK)-> &on_cpu); }  &while (0));
	}' unless defined(&spin_lock_own);
    } else {
	eval 'sub spin_unlock {
	    my($lock) = @_;
    	    eval q({  &mb();  ($lock->{lock}) = 0; });
	}' unless defined(&spin_unlock);
	eval 'sub spin_lock {
	    my($lock) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&spin_lock);
	eval 'sub spin_trylock {
	    my($lock) = @_;
    	    eval q((! &test_and_set_bit(0,($lock))));
	}' unless defined(&spin_trylock);
	eval 'sub spin_lock_own {
	    my($LOCK, $LOCATION) = @_;
    	    eval q((( &void)0));
	}' unless defined(&spin_lock_own);
    }
    eval 'sub RW_LOCK_UNLOCKED () {( &rwlock_t) { 0, 0};}' unless defined(&RW_LOCK_UNLOCKED);
    eval 'sub rwlock_init {
        my($x) = @_;
	    eval q( &do { *($x) =  &RW_LOCK_UNLOCKED; }  &while(0));
    }' unless defined(&rwlock_init);
    if((defined(&DEBUG_RWLOCK) ? &DEBUG_RWLOCK : undef)) {
    } else {
	eval 'sub write_lock {
	    my($lock) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&write_lock);
	eval 'sub read_lock {
	    my($lock) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&read_lock);
    }
    eval 'sub write_unlock {
        my($lock) = @_;
	    eval q({  &mb(); *( &volatile \'int\' *)$lock = 0; });
    }' unless defined(&write_unlock);
    eval 'sub read_unlock {
        my($lock) = @_;
	    eval q(\\"(assembly code)\\");
    }' unless defined(&read_unlock);
}
1;
