require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_SYSTEM_H)) {
    eval 'sub __ALPHA_SYSTEM_H () {1;}' unless defined(&__ALPHA_SYSTEM_H);
    require 'linux/config.ph';
    require 'asm/pal.ph';
    require 'asm/page.ph';
    eval 'sub BOOT_PCB () {0x20000000;}' unless defined(&BOOT_PCB);
    eval 'sub BOOT_ADDR () {0x20000000;}' unless defined(&BOOT_ADDR);
    eval 'sub BOOT_SIZE () {(16*1024);}' unless defined(&BOOT_SIZE);
    if(defined(&CONFIG_ALPHA_LEGACY_START_ADDRESS)) {
	eval 'sub KERNEL_START_PHYS () {0x300000;}' unless defined(&KERNEL_START_PHYS);
    } else {
	eval 'sub KERNEL_START_PHYS () {0x800000;}' unless defined(&KERNEL_START_PHYS);
    }
    eval 'sub KERNEL_START () {( &PAGE_OFFSET+ &KERNEL_START_PHYS);}' unless defined(&KERNEL_START);
    eval 'sub SWAPPER_PGD () { &KERNEL_START;}' unless defined(&SWAPPER_PGD);
    eval 'sub INIT_STACK () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x2000);}' unless defined(&INIT_STACK);
    eval 'sub EMPTY_PGT () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x4000);}' unless defined(&EMPTY_PGT);
    eval 'sub EMPTY_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x8000);}' unless defined(&EMPTY_PGE);
    eval 'sub ZERO_PGE () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0xa000);}' unless defined(&ZERO_PGE);
    eval 'sub START_ADDR () {( &PAGE_OFFSET+ &KERNEL_START_PHYS+0x10000);}' unless defined(&START_ADDR);
    eval 'sub PARAM () { &ZERO_PGE;}' unless defined(&PARAM);
    eval 'sub COMMAND_LINE () {(( &PARAM + 0x));}' unless defined(&COMMAND_LINE);
    eval 'sub COMMAND_LINE_SIZE () {256;}' unless defined(&COMMAND_LINE_SIZE);
    eval 'sub INITRD_START () {(* ( &PARAM+0x100));}' unless defined(&INITRD_START);
    eval 'sub INITRD_SIZE () {(* ( &PARAM+0x108));}' unless defined(&INITRD_SIZE);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/kernel.ph';
	eval 'sub __halt () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&__halt);
	eval 'sub prepare_to_switch () {
	    eval q( &do { }  &while(0));
	}' unless defined(&prepare_to_switch);
	eval 'sub switch_to {
	    my($prev,$next,$last) = @_;
    	    eval q( &do { \'unsigned long pcbb\';  &current = ($next);  &pcbb =  &virt_to_phys( ($current->{thread})); ($last) =  &alpha_switch_to( &pcbb, ($prev));  &check_mmu_context(); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub mb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&mb);
	eval 'sub rmb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&rmb);
	eval 'sub wmb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&wmb);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub smp_mb () {
	        eval q( &mb());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &rmb());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &wmb());
	    }' unless defined(&smp_wmb);
	} else {
	    eval 'sub smp_mb () {
	        eval q( &barrier());
	    }' unless defined(&smp_mb);
	    eval 'sub smp_rmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_rmb);
	    eval 'sub smp_wmb () {
	        eval q( &barrier());
	    }' unless defined(&smp_wmb);
	}
	eval 'sub set_mb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &mb(); }  &while (0));
	}' unless defined(&set_mb);
	eval 'sub set_wmb {
	    my($var, $value) = @_;
    	    eval q( &do { $var = $value;  &wmb(); }  &while (0));
	}' unless defined(&set_wmb);
	eval 'sub imb () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&imb);
	eval 'sub draina () {
	    eval q(\\"(assembly code)\\");
	}' unless defined(&draina);
	eval("sub IMPLVER_EV4 () { 0; }") unless defined(&IMPLVER_EV4);
	eval("sub IMPLVER_EV5 () { 1; }") unless defined(&IMPLVER_EV5);
	eval("sub IMPLVER_EV6 () { 2; }") unless defined(&IMPLVER_EV6);
	if(defined(&CONFIG_ALPHA_GENERIC)) {
	    eval 'sub implver () {
	        eval q(\\"(assembly code)\\");
	    }' unless defined(&implver);
	} else {
	    if(defined(&CONFIG_ALPHA_EV4)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV4);
		}' unless defined(&implver);
	    }
	    if(defined(&CONFIG_ALPHA_EV5)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV5);
		}' unless defined(&implver);
	    }
	    if(defined( &CONFIG_ALPHA_EV6) || defined( &CONFIG_ALPHA_EV67)) {
		eval 'sub implver () {
		    eval q( &IMPLVER_EV6);
		}' unless defined(&implver);
	    }
	}
	eval("sub AMASK_BWX () { (1UL<<0); }") unless defined(&AMASK_BWX);
	eval("sub AMASK_FIX () { (1UL<<1); }") unless defined(&AMASK_FIX);
	eval("sub AMASK_MAX () { (1UL<<8); }") unless defined(&AMASK_MAX);
	eval("sub AMASK_PRECISE_TRAP () { (1UL<<9); }") unless defined(&AMASK_PRECISE_TRAP);
	eval 'sub amask {
	    my($mask) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&amask);
	eval 'sub __CALL_PAL_R0 {
	    my($NAME, $TYPE) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_R0);
	eval 'sub __CALL_PAL_W1 {
	    my($NAME, $TYPE0) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_W1);
	eval 'sub __CALL_PAL_W2 {
	    my($NAME, $TYPE0, $TYPE1) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_W2);
	eval 'sub __CALL_PAL_RW1 {
	    my($NAME, $RTYPE, $TYPE0) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_RW1);
	eval 'sub __CALL_PAL_RW2 {
	    my($NAME, $RTYPE, $TYPE0, $TYPE1) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__CALL_PAL_RW2);
	eval 'sub IPL_MIN () {0;}' unless defined(&IPL_MIN);
	eval 'sub IPL_SW0 () {1;}' unless defined(&IPL_SW0);
	eval 'sub IPL_SW1 () {2;}' unless defined(&IPL_SW1);
	eval 'sub IPL_DEV0 () {3;}' unless defined(&IPL_DEV0);
	eval 'sub IPL_DEV1 () {4;}' unless defined(&IPL_DEV1);
	eval 'sub IPL_TIMER () {5;}' unless defined(&IPL_TIMER);
	eval 'sub IPL_PERF () {6;}' unless defined(&IPL_PERF);
	eval 'sub IPL_POWERFAIL () {6;}' unless defined(&IPL_POWERFAIL);
	eval 'sub IPL_MCHECK () {7;}' unless defined(&IPL_MCHECK);
	eval 'sub IPL_MAX () {7;}' unless defined(&IPL_MAX);
	if(defined(&CONFIG_ALPHA_BROKEN_IRQ_MASK)) {
	    undef(&IPL_MIN) if defined(&IPL_MIN);
	    eval 'sub IPL_MIN () { &__min_ipl;}' unless defined(&IPL_MIN);
	}
	eval 'sub getipl () {
	    eval q(( &rdps() & 7));
	}' unless defined(&getipl);
	eval 'sub setipl {
	    my($ipl) = @_;
    	    eval q((( &void)  &swpipl($ipl)));
	}' unless defined(&setipl);
	eval 'sub __cli () {
	    eval q( &do {  &setipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&__cli);
	eval 'sub __sti () {
	    eval q( &do {  &barrier();  &setipl( &IPL_MIN); }  &while(0));
	}' unless defined(&__sti);
	eval 'sub __save_flags {
	    my($flags) = @_;
    	    eval q((($flags) =  &rdps()));
	}' unless defined(&__save_flags);
	eval 'sub __save_and_cli {
	    my($flags) = @_;
    	    eval q( &do { ($flags) =  &swpipl( &IPL_MAX);  &barrier(); }  &while(0));
	}' unless defined(&__save_and_cli);
	eval 'sub __restore_flags {
	    my($flags) = @_;
    	    eval q( &do {  &barrier();  &setipl($flags);  &barrier(); }  &while(0));
	}' unless defined(&__restore_flags);
	eval 'sub local_irq_save {
	    my($flags) = @_;
    	    eval q( &__save_and_cli($flags));
	}' unless defined(&local_irq_save);
	eval 'sub local_irq_restore {
	    my($flags) = @_;
    	    eval q( &__restore_flags($flags));
	}' unless defined(&local_irq_restore);
	eval 'sub local_irq_disable () {
	    eval q( &__cli());
	}' unless defined(&local_irq_disable);
	eval 'sub local_irq_enable () {
	    eval q( &__sti());
	}' unless defined(&local_irq_enable);
	if(defined(&CONFIG_SMP)) {
	    eval 'sub save_and_cli {
	        my($flags) = @_;
    		eval q(( &save_flags($flags),  &cli()));
	    }' unless defined(&save_and_cli);
	    eval 'sub cli () {
	        eval q( &__global_cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__global_sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($flags) = @_;
    		eval q((($flags) =  &__global_save_flags()));
	    }' unless defined(&save_flags);
	    eval 'sub restore_flags {
	        my($flags) = @_;
    		eval q( &__global_restore_flags($flags));
	    }' unless defined(&restore_flags);
	} else {
	    eval 'sub cli () {
	        eval q( &__cli());
	    }' unless defined(&cli);
	    eval 'sub sti () {
	        eval q( &__sti());
	    }' unless defined(&sti);
	    eval 'sub save_flags {
	        my($flags) = @_;
    		eval q( &__save_flags($flags));
	    }' unless defined(&save_flags);
	    eval 'sub save_and_cli {
	        my($flags) = @_;
    		eval q( &__save_and_cli($flags));
	    }' unless defined(&save_and_cli);
	    eval 'sub restore_flags {
	        my($flags) = @_;
    		eval q( &__restore_flags($flags));
	    }' unless defined(&restore_flags);
	}
	eval 'sub __tbi () {"(assembly code)";}' unless defined(&__tbi);
	eval 'sub tbi {
	    my($x,$y) = @_;
    	    eval q( &__tbi($x, &__r17=($y),\\"1\\" ( &__r17)));
	}' unless defined(&tbi);
	eval 'sub tbisi {
	    my($x) = @_;
    	    eval q( &__tbi(1, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisi);
	eval 'sub tbisd {
	    my($x) = @_;
    	    eval q( &__tbi(2, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbisd);
	eval 'sub tbis {
	    my($x) = @_;
    	    eval q( &__tbi(3, &__r17=($x),\\"1\\" ( &__r17)));
	}' unless defined(&tbis);
	eval 'sub tbiap () {
	    eval q( &__tbi(-1, ));
	}' unless defined(&tbiap);
	eval 'sub tbia () {
	    eval q( &__tbi(-2, ));
	}' unless defined(&tbia);
	if(defined(&CONFIG_SMP)) {
	}
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __xchg_u64 {
	    my($m,$val) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__xchg_u64);
	eval 'sub __xchg {
	    my($ptr,$x,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__xchg_u32($ptr, $x);  &case 8:  &__xchg_u64($ptr, $x); }  &__xchg_called_with_bad_pointer(); $x; });
	}' unless defined(&__xchg);
	eval 'sub xchg {
	    my($ptr,$x) = @_;
    	    eval q(({  &__typeof__(*)  &_x_ = ; ( &__typeof__(*))  &__xchg(,  &_x_, $sizeof{($ptr)}); }));
	}' unless defined(&xchg);
	eval 'sub tas {
	    my($ptr) = @_;
    	    eval q(( &xchg(($ptr),1)));
	}' unless defined(&tas);
	eval 'sub __HAVE_ARCH_CMPXCHG () {1;}' unless defined(&__HAVE_ARCH_CMPXCHG);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u32 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u32);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __cmpxchg_u64 {
	    my($m,$old,$new) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__cmpxchg_u64);
	eval 'sub __cmpxchg {
	    my($ptr,$old,$new,$size) = @_;
    	    eval q({  &switch ($size) {  &case 4:  &__cmpxchg_u32($ptr, $old, $new);  &case 8:  &__cmpxchg_u64($ptr, $old, $new); }  &__cmpxchg_called_with_bad_pointer(); $old; });
	}' unless defined(&__cmpxchg);
	eval 'sub cmpxchg {
	    my($ptr,$o,$n) = @_;
    	    eval q(({  &__typeof__(*)  &_o_ = ;  &__typeof__(*)  &_n_ = ; ( &__typeof__(*))  &__cmpxchg(,  &_o_,  &_n_, $sizeof{($ptr)}); }));
	}' unless defined(&cmpxchg);
    }
}
1;
